'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _base = require('./base');

var _base2 = _interopRequireDefault(_base);

var _parser = require('./parser');

var _parser2 = _interopRequireDefault(_parser);

var _package = require('../package.json');

var _package2 = _interopRequireDefault(_package);

require('./config');

var _jestValidate = require('jest-validate');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BUILTIN_FLAGS = [{ name: 'debug', hidden: true }, { name: 'no-color', hidden: true }];

var Command = function (_Base) {
  (0, _inherits3.default)(Command, _Base);
  (0, _createClass3.default)(Command, null, [{
    key: 'id',
    get: function get() {
      return this.command ? this.topic + ':' + this.command : this.topic;
    }
  }, {
    key: 'flags',
    get: function get() {
      return this._flags.concat(BUILTIN_FLAGS);
    },
    set: function set(flags) {
      this._flags = flags;
    }
  }, {
    key: 'args',
    get: function get() {
      return this._args;
    },
    set: function set(args) {
      this._args = args;
    }
  }]);

  function Command() {
    var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    (0, _classCallCheck3.default)(this, Command);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Command.__proto__ || (0, _getPrototypeOf2.default)(Command)).call(this, config));

    _this.validate();
    _this.argv = _this.config.argv.slice(1);
    _this.parser = new _parser2.default(_this);
    return _this;
  }

  // prevent setting things that need to be static


  (0, _createClass3.default)(Command, [{
    key: 'init',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return (0, _get3.default)(Command.prototype.__proto__ || (0, _getPrototypeOf2.default)(Command.prototype), 'init', this).call(this);

              case 2:
                _context.next = 4;
                return this.parser.parse();

              case 4:
                this.flags = this.parser.flags;
                this.args = this.parser.args;
                this.argv = this.parser.argv;
                if (this.flags.debug) this.config.debug = 1;

              case 8:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function init() {
        return _ref.apply(this, arguments);
      }

      return init;
    }()
  }, {
    key: 'validate',
    value: function validate() {
      var exampleFlag = {
        name: 'app',
        char: 'a',
        hidden: false,
        hasValue: false,
        required: false,
        optional: true,
        description: 'description of flag',
        parse: function parse() {},
        default: function _default() {}
      };
      var exampleArg = {
        name: 'FILE',
        required: true,
        optional: false,
        hidden: false
      };
      var id = this.constructor.id;
      (0, _jestValidate.validate)(this.constructor, {
        comment: 'Command: ' + id,
        exampleConfig: {
          topic: 'apps',
          command: 'info',
          description: 'description of my command',
          hidden: true,
          variableArgs: false,
          usage: 'how to use the command',
          help: 'long form help text',
          aliases: ['-v', '--version'],
          args: [exampleArg],
          flags: [exampleFlag],
          _args: [],
          _flags: [],
          __args: [],
          __flags: []
        }
      });
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = (0, _getIterator3.default)(this.constructor.flags), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var _flag = _step.value;

          (0, _jestValidate.validate)(_flag, {
            comment: id + ' flag: ' + _flag.name,
            exampleConfig: exampleFlag
          });
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;
      var _iteratorError2 = undefined;

      try {
        for (var _iterator2 = (0, _getIterator3.default)(this.constructor.args), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          var _arg = _step2.value;

          (0, _jestValidate.validate)(_arg, {
            comment: id + ' arg: ' + _arg.name,
            exampleConfig: exampleArg
          });
        }
      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2.return) {
            _iterator2.return();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }
    }

    /**
     * actual command run code goes here
     */

  }, {
    key: 'run',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2() {
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                throw new Error('must implement run');

              case 1:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function run() {
        return _ref2.apply(this, arguments);
      }

      return run;
    }()

    /**
     * runs init/run/done lifecycle
     */

  }, {
    key: '_run',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3() {
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this.init();

              case 2:
                _context3.next = 4;
                return this.run();

              case 4:
                _context3.next = 6;
                return this.done();

              case 6:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function _run() {
        return _ref3.apply(this, arguments);
      }

      return _run;
    }()
  }, {
    key: 'done',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4() {
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.next = 2;
                return (0, _get3.default)(Command.prototype.__proto__ || (0, _getPrototypeOf2.default)(Command.prototype), 'done', this).call(this);

              case 2:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function done() {
        return _ref4.apply(this, arguments);
      }

      return done;
    }()
  }]);
  return Command;
}(_base2.default);

Command.aliases = [];
Command.variableArgs = false;
Command._flags = [];
Command._args = [];
exports.default = Command;