'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _os = require('os');

var _os2 = _interopRequireDefault(_os);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// import {validate} from 'jest-validate'

// const examplePJSON: CLI = {
//   node: process.version.split('v')[1],
//   defaultCommand: 'help',
//   plugins: ['heroku-cli-debug'],
//   s3: {
//     host: 's3-host.heroku.com',
//     bucket: 'mys3bucket'
//   }
// }

// const exampleOptions: ConfigOptions = {
//   mock: true,
//   argv: ['heroku', 'apps:info'],
//   root: '/path/to/cli/root',
//   updateDisabled: 'update disabled. update with `npm update -g heroku-cli`',
//   binPath: '/path/to/cli/bin/run',
//   channel: 'stable'
// }

function debug() {
  var HEROKU_DEBUG = process.env.HEROKU_DEBUG;
  if (HEROKU_DEBUG === 'true') return 1;
  if (HEROKU_DEBUG) return parseInt(HEROKU_DEBUG);
  return 0;
}

var Dirs = function () {
  function Dirs(config) {
    (0, _classCallCheck3.default)(this, Dirs);

    this._config = config;
  }

  (0, _createClass3.default)(Dirs, [{
    key: '_mkdirp',
    value: function _mkdirp(dir) {
      this._fs.mkdirpSync(dir);
    }
  }, {
    key: '_fetch',
    value: function _fetch(category, d) {
      d = d || _path2.default.join(this.home, category === 'data' ? '.local/share' : '.' + category);
      if (this.windows) d = process.env.LOCALAPPDATA || d;
      d = process.env.XDG_DATA_HOME || d;
      d = _path2.default.join(d, this._config.name);
      this._mkdirp(d);
      return d;
    }
  }, {
    key: 'toJSON',
    value: function toJSON() {
      return {
        cache: this.cache,
        data: this.data,
        config: this.config,
        home: this.home
      };
    }
  }, {
    key: 'home',
    get: function get() {
      return _os2.default.homedir();
    }
  }, {
    key: 'data',
    get: function get() {
      return this._fetch('data');
    }
  }, {
    key: 'config',
    get: function get() {
      return this._fetch('config');
    }
  }, {
    key: 'cache',
    get: function get() {
      var def = void 0;
      if (process.platform === 'darwin') def = _path2.default.join(this.home, 'Library', 'Caches');
      return this._fetch('cache', def);
    }
  }, {
    key: '_fs',
    get: function get() {
      return require('fs-extra');
    }
  }]);
  return Dirs;
}();

var Config = function () {
  function Config(options) {
    (0, _classCallCheck3.default)(this, Config);

    this._options = options;
    this._pjson = this._options.root
    // flow$ignore
    ? require(_path2.default.join(options.root, 'package.json')) : require('../package.json');
    this.debug = debug() || options.debug || 0;
    this.dirs = new Dirs(this);
    // TODO: make validation work when inherited
    // validate(this._cli, {comment: 'pjson.cli-engine', exampleConfig: examplePJSON})
    // validate(options, {comment: 'config', exampleConfig: exampleOptions})
  }

  (0, _createClass3.default)(Config, [{
    key: 'toJSON',
    value: function toJSON() {
      return {
        name: this.name,
        version: this.version,
        channel: this.channel,
        argv: this.argv,
        mock: this.mock,
        updateDisabled: this.updateDisabled,
        bin: this.bin,
        binPath: this.binPath,
        defaultCommand: this.defaultCommand,
        root: this.root,
        s3: this.s3,
        windows: this.windows,
        debug: this.debug,
        dirs: this.dirs
      };
    }
  }, {
    key: 'name',
    get: function get() {
      return this._pjson.name;
    }
  }, {
    key: 'version',
    get: function get() {
      return this._pjson.version;
    }
  }, {
    key: 'channel',
    get: function get() {
      return this._options.channel || 'stable';
    }
  }, {
    key: 'argv',
    get: function get() {
      return this._options.argv || [];
    }
  }, {
    key: 'mock',
    get: function get() {
      return this._options.mock || false;
    }
  }, {
    key: 'updateDisabled',
    get: function get() {
      return this._options.updateDisabled;
    }
  }, {
    key: 'bin',
    get: function get() {
      return this._cli.bin || this._pjson.name;
    }
  }, {
    key: 'binPath',
    get: function get() {
      return this._options.binPath;
    }
  }, {
    key: 'root',
    get: function get() {
      return this._options.root || _path2.default.join(__dirname, '..');
    }
  }, {
    key: 'defaultCommand',
    get: function get() {
      return this._cli.defaultCommand || 'help';
    }
  }, {
    key: 's3',
    get: function get() {
      return this._cli.s3 || {};
    }
  }, {
    key: '_cli',
    get: function get() {
      return this._pjson['cli-engine'] || {};
    }
  }, {
    key: 'windows',
    get: function get() {
      return _os2.default.platform === 'win32';
    }
  }]);
  return Config;
}();

exports.default = Config;