'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CustomColors = undefined;

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _util = require('util');

var _util2 = _interopRequireDefault(_util);

var _linewrap = require('./linewrap');

var _linewrap2 = _interopRequireDefault(_linewrap);

var _screen = require('./screen');

var _action = require('./action');

var _action2 = _interopRequireDefault(_action);

var _supportsColor = require('supports-color');

var _supportsColor2 = _interopRequireDefault(_supportsColor);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _config = require('../config');

var _config2 = _interopRequireDefault(_config);

var _prettyFormat = require('pretty-format');

var _prettyFormat2 = _interopRequireDefault(_prettyFormat);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ExitError = function (_Error) {
  (0, _inherits3.default)(ExitError, _Error);

  function ExitError(code) {
    (0, _classCallCheck3.default)(this, ExitError);

    var _this = (0, _possibleConstructorReturn3.default)(this, (ExitError.__proto__ || (0, _getPrototypeOf2.default)(ExitError)).call(this, 'Exited with code: ' + code));

    _this.code = code;
    return _this;
  }

  return ExitError;
}(Error);
/* globals
   stream$Writable
   $Shape
 */

var CustomColors = exports.CustomColors = {
  supports: _supportsColor2.default,
  attachment: function attachment(s) {
    return _chalk2.default.cyan(s);
  },
  addon: function addon(s) {
    return _chalk2.default.yellow(s);
  },
  configVar: function configVar(s) {
    return _chalk2.default.green(s);
  },
  release: function release(s) {
    return _chalk2.default.blue.bold(s);
  },
  cmd: function cmd(s) {
    return _chalk2.default.cyan.bold(s);
  },
  app: function app(s) {
    return CustomColors.heroku('\u2B22 ' + s);
  },
  heroku: function heroku(s) {
    if (!CustomColors.supports) return s;
    var has256 = CustomColors.supports.has256 || (process.env.TERM || '').indexOf('256') !== -1;
    return has256 ? '\x1B[38;5;104m' + s + _chalk2.default.styles.reset.open : _chalk2.default.magenta(s);
  }
};

if (['false', '0'].indexOf((process.env.COLOR || '').toLowerCase()) !== -1) CustomColors.supports = false;

function wrap(msg) {
  return (0, _linewrap2.default)(6, _screen.errtermwidth, {
    skipScheme: 'ansi-color',
    skip: /^\$ .*$/
  })(msg);
}

function bangify(msg, c) {
  var lines = msg.split('\n');
  for (var i = 0; i < lines.length; i++) {
    var line = lines[i];
    lines[i] = ' ' + c + line.substr(2, line.length);
  }
  return lines.join('\n');
}

function getErrorMessage(err) {
  var message = void 0;
  if (err.body) {
    // API error
    if (err.body.message) {
      message = _util2.default.inspect(err.body.message);
    } else if (err.body.error) {
      message = _util2.default.inspect(err.body.error);
    }
  }
  // Unhandled error
  if (err.message && err.code) {
    message = _util2.default.inspect(err.code) + ': ' + err.message;
  } else if (err.message) {
    message = err.message;
  }
  return message || _util2.default.inspect(err);
}

var arrow = process.platform === 'win32' ? '!' : '▸';

var StreamOutput = function () {
  function StreamOutput(stream, output) {
    (0, _classCallCheck3.default)(this, StreamOutput);
    this.output = '';

    this.out = output;
    this.stream = stream;
    this.stream.on('error', function (err) {
      if (err.code !== 'EPIPE') throw err;
    });
  }

  (0, _createClass3.default)(StreamOutput, [{
    key: 'write',
    value: function write(msg) {
      if (this.out.config.mock) this.output += msg;else this.stream.write(msg);
    }
  }, {
    key: 'log',
    value: function log(data) {
      var _this2 = this;

      for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }

      var msg = data ? _util2.default.format.apply(_util2.default, [data].concat((0, _toConsumableArray3.default)(args))) : '';
      msg += '\n';
      this.out.action.pause(function () {
        if (_this2.out.config.mock) _this2.output += msg;else _this2.stream.write(msg);
      });
    }
  }]);
  return StreamOutput;
}();

var Output = function () {
  function Output() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    (0, _classCallCheck3.default)(this, Output);

    this.config = options instanceof _config2.default ? options : new _config2.default(options);
    this.stdout = new StreamOutput(process.stdout, this);
    this.stderr = new StreamOutput(process.stderr, this);
    this.action = new _action2.default(this);

    this.color = new Proxy(_chalk2.default, {
      get: function get(chalk, name) {
        if (CustomColors[name]) return CustomColors[name];
        return chalk[name];
      }
    });
  }

  (0, _createClass3.default)(Output, [{
    key: 'init',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function init() {
        return _ref.apply(this, arguments);
      }

      return init;
    }()
  }, {
    key: 'done',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2() {
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                this.showCursor();
                this.action.stop();

              case 2:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function done() {
        return _ref2.apply(this, arguments);
      }

      return done;
    }()
  }, {
    key: 'log',
    value: function log(data) {
      var _stdout;

      for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
        args[_key2 - 1] = arguments[_key2];
      }

      (_stdout = this.stdout).log.apply(_stdout, [data].concat((0, _toConsumableArray3.default)(args)));
    }
  }, {
    key: 'styledJSON',
    value: function styledJSON(obj) {
      var json = (0, _stringify2.default)(obj, null, 2);
      if (CustomColors.supports) {
        var cardinal = require('cardinal');
        var theme = require('cardinal/themes/jq');
        this.log(cardinal.highlight(json, { json: true, theme: theme }));
      } else {
        this.log(json);
      }
    }
  }, {
    key: 'styledHeader',
    value: function styledHeader(header) {
      this.log(this.color.gray('=== ') + this.color.bold(header));
    }
  }, {
    key: 'styledObject',
    value: function styledObject(obj, keys) {
      var _this3 = this;

      var util = require('util');
      var keyLengths = (0, _keys2.default)(obj).map(function (key) {
        return key.toString().length;
      });
      var maxKeyLength = Math.max.apply(Math, keyLengths) + 2;
      function pp(obj) {
        if (typeof obj === 'string' || typeof obj === 'number') {
          return obj;
        } else if ((typeof obj === 'undefined' ? 'undefined' : (0, _typeof3.default)(obj)) === 'object') {
          return (0, _keys2.default)(obj).map(function (k) {
            return k + ': ' + util.inspect(obj[k]);
          }).join(', ');
        } else {
          return util.inspect(obj);
        }
      }
      var logKeyValue = function logKeyValue(key, value) {
        _this3.log(key + ':' + ' '.repeat(maxKeyLength - key.length - 1) + pp(value));
      };
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = (0, _getIterator3.default)(keys || (0, _keys2.default)(obj).sort()), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var key = _step.value;

          var value = obj[key];
          if (Array.isArray(value)) {
            if (value.length > 0) {
              logKeyValue(key, value[0]);
              var _iteratorNormalCompletion2 = true;
              var _didIteratorError2 = false;
              var _iteratorError2 = undefined;

              try {
                for (var _iterator2 = (0, _getIterator3.default)(value.slice(1)), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                  var e = _step2.value;

                  this.log(' '.repeat(maxKeyLength) + pp(e));
                }
              } catch (err) {
                _didIteratorError2 = true;
                _iteratorError2 = err;
              } finally {
                try {
                  if (!_iteratorNormalCompletion2 && _iterator2.return) {
                    _iterator2.return();
                  }
                } finally {
                  if (_didIteratorError2) {
                    throw _iteratorError2;
                  }
                }
              }
            }
          } else if (value !== null && value !== undefined) {
            logKeyValue(key, value);
          }
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }
    }

    /**
     * inspect an object for debugging
     */

  }, {
    key: 'inspect',
    value: function inspect(obj) {
      var _this4 = this;

      this.action.pause(function () {
        _this4.stderr.log((0, _prettyFormat2.default)(obj));
      });
    }
  }, {
    key: 'debug',
    value: function debug(obj) {
      if (this.config.debug) this.action.pause(function () {
        return console.log(obj);
      });
    }
  }, {
    key: 'error',
    value: function error(err) {
      var exitCode = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;

      try {
        if (typeof err === 'string') err = new Error(err);
        this.logError(err);
        if (this.action.task) this.action.stop(this.color.bold.red('!'));
        if (this.config.debug) {
          this.stderr.log(_util2.default.inspect(err));
          this.stderr.log(_util2.default.inspect(this.config));
        } else {
          this.stderr.log(bangify(wrap(getErrorMessage(err)), this.color.red(arrow)));
        }
      } catch (e) {
        console.error('error displaying error');
        console.error(e);
        console.error(err);
      }
      if (exitCode !== false) this.exit(exitCode);
    }
  }, {
    key: 'warn',
    value: function warn(err, prefix) {
      var _this5 = this;

      this.action.pause(function () {
        try {
          prefix = prefix ? prefix + ' ' : '';
          err = typeof err === 'string' ? new Error(err) : err;
          _this5.logError(err);
          if (_this5.config.debug) process.stderr.write('WARNING: ' + prefix) && _this5.stderr.log(_util2.default.inspect(err));else _this5.stderr.log(bangify(wrap(prefix + getErrorMessage(err)), _this5.color.yellow(arrow)));
        } catch (e) {
          console.error('error displaying warning');
          console.error(e);
          console.error(err);
        }
      });
    }
  }, {
    key: 'logError',
    value: function logError(err) {
      try {
        err = this.color.stripColor(_util2.default.inspect(err));
        this.fs.appendFileSync(this.errlog, err + '\n');
      } catch (err) {
        console.error(err);
      }
    }
  }, {
    key: 'exit',
    value: function exit() {
      var code = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;

      this.showCursor();
      if (this.config.debug) console.error('Exiting with code: ' + code);
      if (this.config.mock) throw new ExitError(code);else process.exit(code);
    }
  }, {
    key: 'showCursor',
    value: function showCursor() {
      var ansi = require('ansi-escapes');
      try {
        if (process.stderr.isTTY) process.stderr.write(ansi.cursorShow);
      } catch (err) {}
    }
  }, {
    key: 'fs',
    get: function get() {
      return require('fs-extra');
    }
  }, {
    key: 'errlog',
    get: function get() {
      return _path2.default.join(this.config.dirs.cache, 'error.log');
    }
  }]);
  return Output;
}();

exports.default = Output;